#!/usr/bin/env python

import numpy
import scipy
import pylab
import matplotlib
import pymorph
from scipy import ndimage

###open image
dna = scipy.misc.imread('dna.jpeg')
###create thresholded image as 8 bit integer
T = pymorph.threshad(dna,10, 255)
T = T.astype(numpy.uint8)

###filter with gaussian and find local maxima
dnaf = ndimage.gaussian_filter(dna, 16)
rmax = pymorph.regmax(dnaf)

###from local maxima create seed image and count the number of seeds
seeds,nr_nuclei = ndimage.label(rmax)

###create structural element for morphological filtering
se = ([0,1,0],[1,1,1],[0,1,0])
###calculate morphological gradient
gr = ndimage.morphology.morphological_gradient(T,footprint=se)

###run watershed algorithm on morphological gradient using the seeds
nuclei = pymorph.cwatershed(gr, seeds)

###print the number of nuclei found
#print nr_nuclei

###show result
matplotlib.pyplot.imshow(nuclei)
#matplotlib.pyplot.gray()
matplotlib.pyplot.show()

###this can be used to show the seeds overlaid with the image
#pylab.imshow(pymorph.overlay(dna, rmax))
#pylab.show()




